#include <bits/stdc++.h>

using namespace std;

#define M 7
#define N 7

int solutions = 0;  // number of solutions (must be 0 when the search starts)
bool grid[M][N];    // all elements false when the search starts
int counter = 0;    // number of visited cells (must be 0 when the search starts)

long long calls = 0;

void search(int x = 0, int y = 0) {
    calls++;

    if(x < 0 || x >= M || y < 0 || y >= N) return;  // Oops... gonna out of the grid!
    if(grid[x][y]) return;      // Oops... cannot visit the same cell twice!
    if(x == M-1 && y == N-1) {  // this cell must be the last one
        if(counter+1 == M*N) solutions += 2;    // this is a solution, and a symmetric one do exist
        return;
    }
    
    // visit cell
    grid[x][y] = true;
    counter++;

    if(x == 0 && y == 0) search(x+1, y);    // always start going down
    else {
        search(x+1, y); // go down
        search(x, y+1); // go right
        search(x-1, y); // go up
        search(x, y-1); // go left
    }
    
    // unroll
    grid[x][y] = false;
    counter--;
}

int main() {
    clock_t start_time = clock();
    search();
    clock_t elapsed_time = clock() - start_time;
    cout << "solutions = " << solutions << "\ntime (s) = " << fixed << static_cast<double>(elapsed_time) / CLOCKS_PER_SEC << "\ncalls = " << calls << endl;

    return 0;
}
