#include <bits/stdc++.h>

using namespace std;

#define M 7
#define N 7

int solutions = 0;      // number of solutions (must be 0 when the search starts)
bool grid[M+2][N+2];    // all elements false when the search starts, but the boundary
int counter = 0;        // number of visited cells (must be 0 when the search starts)

long long calls = 0;

void search(int x = 1, int y = 1) {
    calls++;

    if(grid[x][y]) return;      // Oops... cannot visit the same cell twice!
    if(x == M && y == N) {      // this cell must be the last one
        if(counter+1 == M*N) solutions += 2;    // this is a solution, and a symmetric one do exist
        return;
    }
    
    // don't split!
    if(grid[x-1][y] && grid[x+1][y] && !grid[x][y-1] && !grid[x][y+1]) return;
    if(grid[x][y-1] && grid[x][y+1] && !grid[x-1][y] && !grid[x+1][y]) return;
    
    // visit cell
    grid[x][y] = true;
    counter++;

    if(x == 1 && y == 1) search(x+1, y);    // always start going down
    else {
        search(x+1, y); // go down
        search(x, y+1); // go right
        search(x-1, y); // go up
        search(x, y-1); // go left
    }
    
    // unroll
    grid[x][y] = false;
    counter--;
}

int main() {
    // init boundary
    for(int x = 0; x < M+2; x++) grid[x][0] = grid[x][N+1] = true;
    for(int y = 0; y < N+2; y++) grid[0][y] = grid[M+1][y] = true;

    clock_t start_time = clock();
    search();
    clock_t elapsed_time = clock() - start_time;
    cout << "solutions = " << solutions << "\ntime (s) = " << fixed << static_cast<double>(elapsed_time) / CLOCKS_PER_SEC << "\ncalls = " << calls << endl;

    return 0;
}
